/**
 * Copyright narutohyper ( http://wonderfl.net/user/narutohyper )
 * MIT License ( http://www.opensource.org/licenses/mit-license.php )
 * Downloaded from: http://wonderfl.net/c/qlAF
 */

package {
	import alternativ5.engine3d.materials.FillMaterial;
	import alternativ5.engine3d.materials.TextureMaterial;
	import alternativ5.engine3d.primitives.Box;
	import alternativ5.engine3d.events.MouseEvent3D
	import alternativ5.types.Point3D;
	import alternativ5.types.Texture;

	import flash.display.Sprite;
	import flash.display.BitmapData;
	import flash.text.*;
	import flash.geom.*;
	
	[SWF(width = 465, height = 465, frameRate = 60,backgroundColor="0x000000")]
	/**
	 * Alternativa3D Tips TextureMaterialのbitmapDataの書き換え
	 * サイコロクリックでBitmapDataが変わります。
	 * 151行目以降のコメントを参照いてください
	 * @narutohype
	 */
	public class SimpleDemo extends Sprite {

		
		public function SimpleDemo():void {
			// テンプレートを作成します
			var template:BasicTemplate = new BasicTemplate();
			addChild(template);



			//Cameraの位置を手前に動かす
			template.camera.coords=new Point3D(500,-500,800);

			//BitmapData、Texture格納用の配列の作成
			var bitmapArray:Array=[];
			var textureArray:Array=[];
			var textureMaterialArray:Array=[];

			//お絵かき用のSpriteを用意する
			var canvas:Sprite=new Sprite()

			//サイコロ目1
			canvas.graphics.clear();
			canvas.graphics.beginFill(0xFCFCFC);
			canvas.graphics.drawRect(0,0,400,400);
			canvas.graphics.beginFill(0xFF0000);
			canvas.graphics.drawCircle(200, 200,80)
			bitmapArray.push(new BitmapData(400,400,true,0xFFFFFF));
			bitmapArray[0].draw(canvas)
			//Textureを作成
			textureArray.push(new Texture(bitmapArray[0]));
			//TextureMaterialを作成
			textureMaterialArray.push(new TextureMaterial(textureArray[0],1,true,true));

			//残り５面を作成（上記を繰り返し）

			//サイコロ目2
			canvas.graphics.clear();
			canvas.graphics.beginFill(0xF9F9F9);
			canvas.graphics.drawRect(0,0,400,400);
			canvas.graphics.beginFill(0x333333);
			canvas.graphics.drawCircle(100, 100,40)
			canvas.graphics.drawCircle(300, 300,40)
			bitmapArray.push(new BitmapData(400,400,true,0xFFFFFF));
			bitmapArray[1].draw(canvas)
			textureArray.push(new Texture(bitmapArray[1]));
			textureMaterialArray.push(new TextureMaterial(textureArray[1],1,true,true));

			//サイコロ目3
			canvas.graphics.clear();
			canvas.graphics.beginFill(0xF6F6F6);
			canvas.graphics.drawRect(0,0,400,400);
			canvas.graphics.beginFill(0x333333);
			canvas.graphics.drawCircle(100, 100,40)
			canvas.graphics.drawCircle(200, 200,40)
			canvas.graphics.drawCircle(300, 300,40)
			bitmapArray.push(new BitmapData(400,400,true,0xFFFFFF));
			bitmapArray[2].draw(canvas)
			textureArray.push(new Texture(bitmapArray[2]));
			textureMaterialArray.push(new TextureMaterial(textureArray[2],1,true,true));

			//サイコロ目4
			canvas.graphics.clear();
			canvas.graphics.beginFill(0xF3F3F3);
			canvas.graphics.drawRect(0,0,400,400);
			canvas.graphics.beginFill(0x333333);
			canvas.graphics.drawCircle(100, 100,40)
			canvas.graphics.drawCircle(100, 300,40)
			canvas.graphics.drawCircle(300, 100,40)
			canvas.graphics.drawCircle(300, 300,40)
			bitmapArray.push(new BitmapData(400,400,true,0xFFFFFF));
			bitmapArray[3].draw(canvas)
			textureArray.push(new Texture(bitmapArray[3]));
			textureMaterialArray.push(new TextureMaterial(textureArray[3],1,true,true));


			//サイコロ目5
			canvas.graphics.clear();
			canvas.graphics.beginFill(0xF0F0F0);
			canvas.graphics.drawRect(0,0,400,400);
			canvas.graphics.beginFill(0x333333);
			canvas.graphics.drawCircle(100, 100,40)
			canvas.graphics.drawCircle(100, 300,40)
			canvas.graphics.drawCircle(200, 200,40)
			canvas.graphics.drawCircle(300, 100,40)
			canvas.graphics.drawCircle(300, 300,40)
			bitmapArray.push(new BitmapData(400,400,true,0xFFFFFF));
			bitmapArray[4].draw(canvas)
			textureArray.push(new Texture(bitmapArray[4]));
			textureMaterialArray.push(new TextureMaterial(textureArray[4],1,true,true));


			//サイコロ目6
			canvas.graphics.clear();
			canvas.graphics.beginFill(0xCCCCCC);
			canvas.graphics.drawRect(0,0,400,400);
			canvas.graphics.beginFill(0x333333);
			canvas.graphics.drawCircle(100, 100,40)
			canvas.graphics.drawCircle(100, 200,40)
			canvas.graphics.drawCircle(100, 300,40)
			canvas.graphics.drawCircle(300, 100,40)
			canvas.graphics.drawCircle(300, 200,40)
			canvas.graphics.drawCircle(300, 300,40)
			bitmapArray.push(new BitmapData(400,400,true,0xFFFFFF));
			bitmapArray[5].draw(canvas)
			textureArray.push(new Texture(bitmapArray[5]));
			textureMaterialArray.push(new TextureMaterial(textureArray[5],1,true,true));

			// プリミティブを作成します
			var box:Box = new Box(400,400,400,1,1,1);
			box.cloneMaterialToAllSurfaces(textureMaterialArray[0]);
			
			template.scene.root.addChild(box);



			//-------------------------------------------------------
			//プリミティブのロールオーバー、クリックを有効にする為
			//viewのbuttonModeとinteractiveをtrueにする
			//-------------------------------------------------------
			template.view.buttonMode = true;
			template.view.interactive = true;

			//-------------------------------------------------------
			//プリミティブにロールオーバー、クリックのリスナーを追加 
			//-------------------------------------------------------
			box.addEventListener(MouseEvent3D.CLICK, onClick);

			var counter:uint=0;
			var tm:TextureMaterial

			function onClick(e:MouseEvent3D):void{
				counter++
				if (counter==1) {
					//TextureMaterialのtextureを書き換える
					//指定した、suraceのtextureのみ変わります
					TextureMaterial(box.surfaces['top'].material).texture=textureArray[1];

				} else if (counter==2) {
					//TextureMaterialのtextureのbitmapDataを書き換える
					//参照しているSurface全てのbitmapDataが変わります
					TextureMaterial(box.surfaces['right'].material).texture.bitmapData.draw(bitmapArray[5]);

				} else if (counter==3) {
					//textureに設定したBitmapDataのインスタンスを変更するの可能
					//参照しているSurface全てのbitmapDataが変わります
					bitmapArray[1].draw(bitmapArray[3])

				} else if (counter==4) {
					//------------------------------------
					//But例1
					//------------------------------------
					//textureに設定したBitmapDataを差し替える
					//変更できません
						bitmapArray[1]=bitmapArray[4]

				} else if (counter==5) {
					//------------------------------------
					//But例2
					//------------------------------------
					//TextureMaterialはインスタンス化してもcloneMaterialToAllSurfaces(material)でcloneされ、
					//別なインスタンスになるのでインスタンスのtextureを差し替えても変更はできません。
						tm=new TextureMaterial(textureArray[3],1,true,true)
						box.cloneMaterialToAllSurfaces(tm);
						//変更できません
						tm.texture=textureArray[1];

				} else if (counter==6) {
						//変更できません
						tm.texture.bitmapData.draw(bitmapArray[5]);
				}

			}




			// Event.ENTER_FRAME 時に実行されるレンダリングのイベントです。
			// レンダリング前に実行したい処理を記述します。
			template.onPreRender = function():void {

				// 立方体を回転させます (角度はラジアン)
				box.rotationZ += 1 * Math.PI / 180;

				// マウスがステージの高さ何%の位置にあるか算出
				//var rateY:Number = (mouseY-stage.stageHeight/2)*3;
				
				// カメラの高さの座標を調整
				// イージングの公式 対象の値 += (目標値 - 現在の値) * 減速率
				//template.camera.z += (rateY - template.camera.z) * 0.1;

				// カメラの座標を中央に向かせる
				template.cameraContoller.lookAt(new Point3D());
			}
		}


	}
}



import alternativ5.engine3d.controllers.CameraController;
import alternativ5.engine3d.core.Camera3D;
import alternativ5.engine3d.core.Object3D;
import alternativ5.engine3d.core.Scene3D;
import alternativ5.engine3d.display.View;
import flash.display.Sprite;
import flash.display.StageAlign;
import flash.display.StageQuality;
import flash.display.StageScaleMode;
import flash.events.Event;


/**
 * BasicTemplate for Alternativa3D
 * Alternativa3Dを扱いやすくするためのテンプレートです
 * @author Yasu
 */
class BasicTemplate extends Sprite{
	/**
	 * シーンインスタンスです。
	 */
	public var scene:Scene3D;
	/**
	 * ビューインスタンスです。
	 */
	public var view:View;
	/**
	 * カメラインスタンスです。
	 */
	public var camera:Camera3D;
	/**
	 * カメラコントローラーです。
	 */
	public var cameraContoller:CameraController;
	
	private var _viewWidth:int;
	private var _viewHeight:int;
	private var _scaleToStage:Boolean;

	/**
	 * 新しい BasicTemplate インスタンスを作成します。
	 * @param	viewWidth
	 * @param	viewHeight
	 * @param	scaleToStage
	 */
	public function BasicTemplate(viewWidth:int=640, viewHeight:int=480, scaleToStage:Boolean = true) {
		_viewWidth = viewWidth;
		_viewHeight = viewHeight;
		_scaleToStage = scaleToStage;
		
		// Creating scene
		scene = new Scene3D();
		scene.splitAnalysis = false; // not analysis for performance
		scene.root = new Object3D();
		
		// Adding camera
		camera = new Camera3D();
		camera.z = -1000;
		scene.root.addChild(camera);
		
		// camera contoller
		cameraContoller = new CameraController(this);
		cameraContoller.camera = camera;
		
		// set view
		view = new View();
		view.camera = camera;
		addChild(view);
		
		// stage
		if (stage) init();
		else addEventListener(Event.ADDED_TO_STAGE, init);
	}
	
	/**
	 * 初期化されたときに実行されるイベントです。
	 * 初期化時に実行したい処理をオーバーライドして記述します。
	 */
	protected function atInit():void {}
	
	/**
	 * 初期化されたときに実行されるイベントです。
	 * 初期化時に実行したい処理を記述します。
	 */
	private var _onInit:Function = function():void { };
	public function get onInit():Function { return _onInit; }
	public function set onInit(value:Function):void {
		_onInit = value;
	}
	
	/**
	 * Event.ENTER_FRAME 時に実行されるレンダリングのイベントです。
	 * レンダリング前に実行したい処理をオーバーライドして記述します。
	 */
	protected function atPreRender():void {}
	
	/**
	 * Event.ENTER_FRAME 時に実行されるレンダリングのイベントです。
	 * レンダリング前に実行したい処理を記述します。
	 */
	private var _onPreRender:Function = function():void{};
	public function get onPreRender():Function { return _onPreRender; }
	public function set onPreRender(value:Function):void {
		_onPreRender = value;
	}
	
	/**
	 * Event.ENTER_FRAME 時に実行されるレンダリングのイベントです。
	 * レンダリング後に実行したい処理をオーバーライドして記述します。
	 */
	protected function atPostRender():void {
	}
	
	/**
	 * Event.ENTER_FRAME 時に実行されるレンダリングのイベントです。
	 * レンダリング後に実行したい処理を記述します。
	 */
	protected var _onPostRender:Function = function():void{};
	public function get onPostRender():Function { return _onPostRender; }
	public function set onPostRender(value:Function):void {
		_onPostRender = value;
	}
	
	/**
	 * レンダリングを開始します。
	 */
	public function startRendering():void {
		addEventListener(Event.ENTER_FRAME, onRenderTick);
	}
	/**
	 * レンダリングを停止します。
	 */
	public function stopRendering():void {
		removeEventListener(Event.ENTER_FRAME, onRenderTick);
	}
	
	/**
	 * シングルレンダリング(レンダリングを一回だけ)を実行します。
	 */
	public function singleRender():void {
		onRenderTick();
	}
	
	/**
	 * @private
	 */
	private function init(e:Event = null):void {
		stage.scaleMode = StageScaleMode.NO_SCALE;
		stage.align = StageAlign.TOP_LEFT;
		stage.quality = StageQuality.HIGH;

		// resize
		stage.addEventListener(Event.RESIZE, onResize);
		onResize(null);
		
		// render
		startRendering();
		
		atInit();
		_onInit();
		
	}
	
	/**
	 * @private
	 */
	private function onRenderTick(e:Event = null):void {
		atPostRender();
		_onPostRender();
		scene.calculate();
		atPreRender();
		_onPreRender();
	}
	
	/**
	 * @private
	 */
	private function onResize(event:Event = null):void {
		if (_scaleToStage) {
			view.width = stage.stageWidth;
			view.height = stage.stageHeight;
		}else {
			view.width = _viewWidth;
			view.height = _viewHeight;
		}
	}
}

